Imports System.Collections.Generic
Imports System.Data.SqlClient

Partial Class BespokeOptions
    Inherits System.Web.UI.UserControl

    Dim BespokeOptionData As Dictionary(Of String, List(Of BespokeInfo))

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        Dim connection As New SqlConnection("Data Source=TFSRTM;Initial Catalog=Fabrikam;Integrated Security=True")

        BespokeOptionData = New Dictionary(Of String, List(Of BespokeInfo))

        Try
            connection.Open()

            Dim cmd As SqlCommand = New SqlCommand("getBespokeOptions", connection)

            cmd.CommandType = Data.CommandType.StoredProcedure
            cmd.Parameters.Add("@productId", Data.SqlDbType.Int).Value = 2

            Dim reader As SqlDataReader = cmd.ExecuteReader()

            While (reader.Read())

                Dim name As String = CType(reader("Name"), String)
                Dim category As String = CType(reader("CategoryName"), String)
                Dim url As String = CType(reader("Url"), String)

                Dim newInfo As New BespokeInfo(name, url)

                If (Me.BespokeOptionData.ContainsKey(category)) Then
                    Dim list As List(Of BespokeInfo) = Me.BespokeOptionData(category)

                Else
                    Dim list As New List(Of BespokeInfo)
                    list.Add(newInfo)
                    Me.BespokeOptionData.Add(category, list)

                End If
            End While


            BespokeOptionsList.DataSource = Me.BespokeOptionData
            BespokeOptionsList.DataBind()

        Catch ex As Exception

        Finally
            connection.Close()
        End Try
        
    End Sub
End Class

