using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class RelatedItems : System.Web.UI.UserControl
{
    public event System.EventHandler AddRelatedItem;

    public void OnAddToCart(object sender, EventArgs args)
    {
        //
        // Trigger our event
        //
        AddRelatedItem(this.ModelImagePermutation, args);
    }

    public string ModelImagePermutation
    {
        get
        {
            //
            // A bit of a demo hack, we should be returning
            // the url of the model image that we want to show for the related item
            // that was selected.  Since we only have a fixed number of model image
            // permutations, we'll hard code the value.        
            //
            return "brown_corduroy.png";
        }
    }
}
