<%@ Page Language="VB" MasterPageFile="~/MasterPage.master" AutoEventWireup="false" CodeFile="ShoppingCart_AJAX.aspx.vb" Inherits="ShoppingCart_AJAX" title="Shopping Cart" %>
<%@ Register Assembly="AjaxControlToolkit" Namespace="AjaxControlToolkit" TagPrefix="cc1" %>
<%@ Register Src="BespokeOptions.ascx" TagName="BespokeOptions" TagPrefix="uc2" %>
<%@ Register Src="RelatedItems.ascx" TagName="RelatedItems" TagPrefix="uc1" %>
<asp:Content ID="Content1" ContentPlaceHolderID="BodyContentPlaceHolder" runat="Server">
    <asp:Panel ID="BackgroundPanel" runat="server" Height="850px" Width="770px" BackImageUrl="~/images/shoppingcart.gif">
        <aspx:ScriptManager ID="ScriptManager1" runat="server" EnablePartialRendering="true">
        </aspx:ScriptManager>
        <br />
        <table class="mainTable">
            <tr>
                <td rowspan="3" class="bespokeCell" valign="top">
                    <br />
                    <br />
                    <br />
                    <br />
                    <span class="selectStyleLabel"><span class="StyleLabel">
                        <br />
                        <br />
                        Select a Style</span> </span>
                    <asp:DropDownList ID="StyleComboBox" runat="server" AutoPostBack="True" DataSourceID="StylesDataSource"
                        DataTextField="name" DataValueField="url" OnSelectedIndexChanged="StyleComboBox_SelectedIndexChanged">
                        <asp:ListItem>Full Length</asp:ListItem>
                        <asp:ListItem>Capri</asp:ListItem>
                        <asp:ListItem>Shorts</asp:ListItem>
                    </asp:DropDownList><br />
                    <br />
                    <uc2:BespokeOptions ID="BespokeOptions" runat="server" />
                    <br />
                    <asp:SqlDataSource ID="StylesDataSource" runat="server" ConnectionString="<%$ ConnectionStrings:ConnectionString %>"
                        SelectCommand="getStyles" SelectCommandType="StoredProcedure">
                        <SelectParameters>
                            <asp:ControlParameter ControlID="ProductInFocusHidden" DefaultValue="2" Name="productId"
                                PropertyName="Value" Type="Int32" />
                        </SelectParameters>
                    </asp:SqlDataSource>
                    <asp:HiddenField ID="ProductInFocusHidden" runat="server" Value="2" />
                </td>
                <td rowspan="3" class="modelCell" valign="top">
                    <br />
                    <br />
                    <aspx:UpdatePanel runat="server" ID="UpdateModelInPlace">
                        <ContentTemplate>
                            <asp:Image ID="ModelImage" runat="server" ImageUrl="~/images/merchandise/bluetop_corduroy.png" /><br />
                        </ContentTemplate>
                        <Triggers>
                            <aspx:AsyncPostBackTrigger ControlID="StyleComboBox" EventName="SelectedIndexChanged" />
                        </Triggers>
                    </aspx:UpdatePanel>
                    <br />
                </td>
                <td rowspan="3" class="relatedCell" valign="top">
                    &nbsp;&nbsp;&nbsp;
                    <uc1:RelatedItems ID="RelatedItems1" runat="server" OnAddRelatedItem="OnAddRelatedItem" />
                </td>
            </tr>
            <tr>
            </tr>
            <tr>
            </tr>
        </table>
    </asp:Panel>
</asp:Content>
